#!/usr/bin/perl

package bluetooth;

sub get_blth_devices{

	print "bluetooth::get_blth_devices()\n"; 
	my $count=0;
	my $hcitool_result;
	while ($count < 3) {
		$hcitool_result=`hcitool scan 2>&1`;
		if(($hcitool_result =~ m/Inquiry\s+failed\s*:/i) || ($hcitool_result =~ m/Device\s+is\s+not\s+available\s*:/i)) {	
			print "Waiting for bluetooth device...\n";
			print "\thcitool: ". $hcitool_result."\n";
			sleep 3;	
			$count++;
		}
		else{	
			last;
		}	
	}

	if ( $count == 3 ){
		print "Bluetooth device error...\n";
		return undef;
	}
	
	my @devices;
	foreach (split(/\n/,$hcitool_result)) {
		next if !/((?:[0-9a-f]{2}[:-]){5}[0-9a-f]{2})/i;
		chomp;
		my @tmp=split(/[\t]+/);
		push (@devices, {mac=>$tmp[1],id=>$tmp[2]});
	}
return \@devices if defined @devices;
}		

sub get_blth_services{
	my ($device_to_scan) = @_;
	my @services;
	my $protocol;
	my $channel;
	print "bluetooth::get_blth_services()\n"; 
	
	#Fixme... 
	my @sdptool_result;
	my $count;
	while ($count < 3) {
		print "probing available services for [ ". $device_to_scan->{id} . " - ".$device_to_scan->{mac} ." ]\n";
		@sdptool_result =`sdptool browse $device_to_scan->{mac} 2>&1`;

		if (( $sdptool_result =~ m/Host\s+is\s+down/i ) || ( $sdptool_result =~ m/Permission\s+denied/i ) || ( $sdptool_result =~ m/Connection\s+timed\s+out/i) ){
			print $_."\n";
			sleep 3;
			$count++;
		}else{
			last;
		}
		
	}

	if  ($count == 3){
		print "Bluetooth device error...\n";
		return undef;	
	}
	
	foreach (split(/\n/,$sdptool_result)){ #check for aviable sevices if aviable
		if (/Service Name:\s+([a-zA-Z_ 0-9]+)/i){
			$protocol=$1;		 
		}
		elsif (/Channel:\s+(\d+)/i){
			$channel = $1;
			print "\t Found: ".$protocol." on channel: ".$channel."\n";
			push(@services, {protocol=>$protocol,channel=>$channel});
		}
	}
	return \@services;
}

1;
