#!/usr/bin/perl
# Copyright (C) 2007 Mandriva
#                    Mathieu RENARD <mrenard@mandriva.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
use File::Find ();
use XML::Simple;

package profiles;

my $profiles_path ="/usr/share/drakmsync/profiles/";
my $xml_header =qw(<?xml version="1.0"?>\n);

#get all get all config* files in profiles dir 
#and return a tab of hash with name and file of each profiles found
sub get_profiles{
	my @profiles;
	print "profiles::get_profiles()\n";
	File::Find::find(
			sub {
				my $current_file = $File::Find::name;
				-f $current_file && /^config[0-9]+$/i && push (@profiles, get_profile_name($current_file))
			}, $profiles_path);
	return \@profiles;
}

sub get_profile_name{ #OK
	my ($profile_file) = @_;
	print "profiles::get_profile_name()\n";	
	my $in_xml = new XML::Simple(KeyAttr=>[]);
	my $profile = $in_xml -> XMLin ( $profile_file) ;
	return { name => $profile ->{name}, file => $profile_file };
}

sub get_profiles_by_name{
	my ($profile_name) = @_;
	my $profiles = get_profiles();
	print "profiles::get_profile_by_name(): Looking for $profile_name\n";
	foreach my $profile (@{$profiles}){
		if ($profile->{name} eq $profile_name){
			print "profiles::get_profiles_by_name(): $profile->{name} found\n";
			return $profile;	
		}
	}
	print "profiles::get_profiles_by_name(): $profile_name not found\n";
	return undef;
}

#Get profile detail of the profile file given in entry
sub get_profile_details{
	my ($profile_file) = @_;
	my $in_xml = new XML::Simple(KeyAttr=>[]);
	print "profiles::get_profile_details()\n";	
	return $in_xml->XMLin($profile_file);
}

#Get profile detail of the profile name given in entry
sub get_profile_details_by_name{
	my ($profile_name)= @_;
	my $profile = get_profiles_by_name($profile_name);
	return get_profile_details($profile->{file});
}



